<?
/**
 * EKO WP PLUGIN MODULE HEADER
 *
 * @module: gallery
 * @name: Galeria de Imagens
 * @description: Galeria gerada automaticamente &agrave; partir de uma pasta no servidor.
 * @version: 0.5
 * @created: 2009-04-24
 * @modified: 2009-12-16
 * @author: Igo Santos
 * @author_email: web@igosantos.com
 * @author_url: www.igosantos.com
 * @actions: eko_gallery, eko_gallery_config
 * @required_modules: core
 *
 *    Copyright (C) 2009  Igo Santos <web@igosantos.com>
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/

//update the module database tables
function eko_gallery_db_update()
{
	$sql[0] = "CREATE TABLE IF NOT EXISTS ".EKO_DB_PREFIX."eko_gallery_config(`id` int(11) NOT NULL auto_increment PRIMARY KEY);";
	$sql[1] = "ALTER TABLE ".EKO_DB_PREFIX."eko_gallery_config ADD COLUMN `nome` VARCHAR( 255 ) NOT NULL;";
	$sql[2] = "ALTER TABLE ".EKO_DB_PREFIX."eko_gallery_config ADD COLUMN `valor` VARCHAR( 255 ) NOT NULL;";

	$sql[3] = "INSERT INTO `".EKO_DB_PREFIX."eko_gallery_config` (`id`, `nome`, `valor`) VALUES (1, 'pasta_upload', '".EKO_PLUGIN_DIR."')";
	$sql[4] = "INSERT INTO `".EKO_DB_PREFIX."eko_gallery_config` (`id`, `nome`, `valor`) VALUES (2, 'img_width', '450')";
	$sql[5] = "INSERT INTO `".EKO_DB_PREFIX."eko_gallery_config` (`id`, `nome`, `valor`) VALUES (3, 'img_height', '450')";
	$sql[6] = "INSERT INTO `".EKO_DB_PREFIX."eko_gallery_config` (`id`, `nome`, `valor`) VALUES (4, 'thumb_width', '100')";
	$sql[7] = "INSERT INTO `".EKO_DB_PREFIX."eko_gallery_config` (`id`, `nome`, `valor`) VALUES (5, 'thumb_height', '100')";
	$sql[8] = "INSERT INTO `".EKO_DB_PREFIX."eko_gallery_config` (`id`, `nome`, `valor`) VALUES (6, 'qualidade', '80')";
	
	$sql[9] = "CREATE TABLE IF NOT EXISTS ".EKO_DB_PREFIX."eko_gallery (`id` int(11) NOT NULL auto_increment PRIMARY KEY);";
	$sql[10] = "ALTER TABLE ".EKO_DB_PREFIX."eko_gallery ADD COLUMN `data` DATETIME NOT NULL";
	$sql[11] = "ALTER TABLE ".EKO_DB_PREFIX."eko_gallery ADD COLUMN `nome` VARCHAR( 255 ) NOT NULL;";
	$sql[12] = "ALTER TABLE ".EKO_DB_PREFIX."eko_gallery ADD COLUMN `visitas` INT NOT NULL;";
	
	$ret = array();

	$erros = "";
	
	for($i=0;$i<count($sql);$i++)
	{
		if (!mysql_query($sql[$i])) $erros .="<li>[SQL$i]:".mysql_error()."</li>";
	};
	
	if($erros=="")
	{
		$ret[0] = true;
		$ret[1] = "";
	}
	else
	{
		$ret[0] = false;
		$ret[1] = $erros;
	};

	return $ret;
	
};

//drop previously created database tables
function eko_gallery_db_drop()
{
	$sql[0] = "DROP TABLE IF EXISTS ".EKO_DB_PREFIX."eko_gallery_config;";
	$sql[1] = "DROP TABLE IF EXISTS ".EKO_DB_PREFIX."eko_gallery;";
	
	$ret = array();

	$erros = "";
	
	for($i=0;$i<count($sql);$i++)
	{
		if (!mysql_query($sql[$i])) $erros .="<li>[SQL$i]:".mysql_error()."</li>";
	};
	
	if($erros=="")
	{
		$ret[0] = true;
		$ret[1] = "";
	}
	else
	{
		$ret[0] = false;
		$ret[1] = $erros;
	};

	return $ret;
};

//check if the required database tables are installed.
function eko_gallery_db_check()
{
	$sql[0] = "SELECT id,nome,valor FROM ".EKO_DB_PREFIX."eko_gallery_config LIMIT 1;";
	$sql[1] = "SELECT id,data,nome,visitas FROM ".EKO_DB_PREFIX."eko_gallery LIMIT 1;";
	
	for ($i=0;$i<count($sql);$i++) if (!mysql_query($sql[$i])) return false;
	
	return true;
};

//the module css
function eko_gallery_css()
{
	?>

    /* eko_gallery_css <-style> */
		.eko_gallery_img {
			position:relative;
			padding:10px;
			text-align:center;
		}
		
		.eko_gallery_select {
			position:relative;
			padding:10px;
			text-align:center;
		}
		
		.eko_gallery_select select {
			position:relative;
			width:<?=eko_gallery_getconfig("img_width");?>px;
		}
		
		.eko_gallery_thumbs {
			position:relative;
			/* padding:10px; */
			/* height:<?=((eko_gallery_getconfig("thumb_height")) + 20);?>px; */
			/* overflow:auto; */
			text-align:center;
		}

		.eko_gallery_thumbs img {
			margin:5px;
		}
		
		.eko_gallery_thumbnail {
			position:relative;
			margin:5px;
			padding:4px;
		}
		
		.eko_gallery_thumbtable {
			position:relative;
			float:left;
			/* width:<?=eko_gallery_getconfig("thumb_width")?>px;
			height:<?=eko_gallery_getconfig("thumb_height")?>px; */
			width:100%;
		}
		
		.eko_gallery_thumbtable tr td {
			margin:0px;
			padding:0px;
		}
		
		.eko_gallery_thumbtable img {
			border:#ccc 1px solid;
			padding:3px;
		}

    <?
};

//the config form
function eko_gallery_config()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_gallery_db_check())
	{
		_warning("Banco de dados n&atilde;o instalado","As tabelas deste m&oacute;dulo ainda n&atilde;o foram instaladas.","./","OK");
		return;
	}
	
	//check the correct permission!
	eko_core_configform("gallery",13,eko_get_page_url("eko_gallery"));
};

//get the module settings in the config table
function eko_gallery_getconfig($name)
{
	return eko_core_getconfig($name,"gallery");
}

//main action
function eko_gallery()
{
	switch($_REQUEST["eko_action"])
	{
		case 1:
			eko_gallery_config();
			break;
		default:
			eko_gallery_style1();
			break;
	};
};

//show the installed albums
function eko_gallery_style1()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_gallery_db_check())
	{
		_warning("Banco de dados n&atilde;o instalado","As tabelas deste m&oacute;dulo ainda n&atilde;o foram instaladas.","./","OK");
		return;
	}
	
		//check the server directory for new albums
		eko_gallery_updatealbums();

		$w = eko_gallery_getconfig("img_width");
		$h = eko_gallery_getconfig("img_height");
		$q = eko_gallery_getconfig("qualidade");
		$tw = eko_gallery_getconfig("thumb_width");
		$th = eko_gallery_getconfig("thumb_height");
		?>
		<div class="eko_gallery_img">
			<?
			if (isset($_REQUEST["eko_imgfile"])&&$_REQUEST["eko_imgfile"]!="")
			{
				echo "<a href=\"".EKO_PLUGIN_URL."inc/thumb.php?w=2000&h=2000&q=$q&img=". $_GET["eko_imgfile"]. "\" /><img src=\"".EKO_PLUGIN_URL . "inc/thumb.php?w=$w&h=$h&q=$q&img=". $_GET["eko_imgfile"] ."\" alt=\"\" /></a>";
			};
			?>
		</div>
		<div class="eko_gallery_select">
			<select onchange="document.location='<?=eko_get_page_url("eko_gallery","eko_gsid='+this.item(this.selectedIndex).value+'&eko_imgfile=");?>';">
				<option value="">Selecione...</option>
				<?
				$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_gallery ORDER BY nome";
				$rs = mysql_query($sql);
				while($arr = mysql_fetch_array($rs))
				{
					$selected = ($arr["id"]==$_REQUEST["eko_gsid"]) ? "selected=\"selected\"" : "" ;
					?>
					<option value="<?=$arr["id"];?>" <?=$selected;?> ><?=$arr["nome"];?></option>
					<?
				};
				?>
			</select>
		</div>
		<div class="eko_gallery_thumbs">
        <? if (getaccess(13)) {?>
        <div><a href="<?=eko_get_page_url("eko_gallery","eko_action=1");?>">Configurar m&oacute;dulo</a></div>
        <? } ?>
			<?
			if(isset($_GET["eko_gsid"])&&$_GET["eko_gsid"]!="")
			{
				$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_gallery WHERE id = ".$_GET["eko_gsid"];
				if($rs=mysql_query($sql))
				{
					$arr = mysql_fetch_array($rs);
					$album = $arr["nome"];
					$pasta = eko_gallery_getconfig("pasta_upload");
					$dir = $pasta."/".$album;
					if (is_dir($dir))
					{
						$dirhandler = opendir($dir);
						while($diritem = readdir($dirhandler))
						{
	
							$ext = strtolower(end(explode('.',$diritem))); 
							if($ext=="jpg")
							{
								
								echo "<a href=\"".eko_get_page_url("eko_gallery","eko_gsid=".$_REQUEST["eko_gsid"]."&eko_imgfile=$dir/$diritem")."\" /><img src=\"".EKO_PLUGIN_URL . "inc/thumb.php?w=$tw&h=$th&q=60&img=$dir/$diritem" ."\" alt=\"\" /></a>";
								//echo $diritem."-";
							};
						};
					};
					
					
				}
				else
				{
					_error("N&atilde; foi poss&iacute;vel listar fotos deste &aacute;lbum:","<li>".mysql_error()."</li>");
				};
			}
			else
			{
			};
			?>
		</div>
		<?
}

//deprecated function
function eko_gallery_style2()
{
	return eko_style_gallery_style1();
}

//check the albums directory and update the database 
function eko_gallery_updatealbums()
{
	$tmpdir = eko_gallery_getconfig("pasta_upload");
	//echo $tmpdir;
	if (is_dir($tmpdir))
	{
		//echo "<option>Selecione...</option>";
		$tmpdirhandler = opendir($tmpdir);
		$count = 0;
		while($diritem = readdir($tmpdirhandler))
		{
			//$dirs = array();
			if (is_dir($tmpdir."/".$diritem)&&$diritem!="."&&$diritem!="..")
			{
				
				$data = substr($diritem,0,10);
				if(strtotime($data))
				{
					$data = substr($diritem,0,10);
				}
				else
				{
					$data = "";
				};

				$sql = "SELECT id FROM ".EKO_DB_PREFIX."eko_gallery WHERE nome = '$diritem'";
				$rs = mysql_query($sql);
				if (mysql_num_rows($rs)==0)
				{
					$sql = "INSERT INTO ".EKO_DB_PREFIX."eko_gallery VALUES (NULL,CURRENT_TIMESTAMP,'$diritem',0);";
					if($rs_ = mysql_query($sql))
					{
						if ($data!="")
						{
							$sql = "UPDATE ".EKO_DB_PREFIX."eko_gallery SET data = '".date("Y-m-d",strtotime($data))."' WHERE id = ".mysql_insert_id();
							mysql_query($sql);
						};

						echo "<b>[add][$data][$diritem]</b><br />";
					};
				}
				else
				{
					//echo "[ok][$data][$diritem]<br />";
				};

				$dirs[$count] = $diritem;
				//echo "[$count] = $diritem<br />";
				$count++;
			};
		}
		closedir($tmpdirhandler);
		
		//echo "[--]<br />";
		//echo "[".count($dirs)."]<br />";
		//echo "[--]<br />";
		
		$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_gallery";
		$rs = mysql_query($sql);
		
		while($arr=mysql_fetch_array($rs))
		{
			$flag = false;
			for ($i=0;$i<count($dirs);$i++)
			{
				if($arr["nome"]==$dirs[$i])
				{
					$flag = true;
					//echo "[$i]][".$arr["nome"]."] == [".$dirs[$i]."]<br />";
				}
				else
				{
					//echo "[$i][".$arr["nome"]."] != [".$dirs[$i]."]<br />";
				};
			};
			
			if (!$flag)
			{
				
				$sql = "DELETE FROM ".EKO_DB_PREFIX."eko_gallery WHERE id = ".$arr["id"];
				mysql_query($sql);
				echo "<b>[del][".$arr["nome"]."]</b><br />";
			};
		};
	}
	else
	{
		_error("Erro ao acessar pasta da galeria:","<li>A pasta configurada n&atilde;o &eacute; v&aacute;lida.</li>");
	};
};

add_action("eko_css","eko_gallery_css");

?>