<?
/**
 * EKO WP PLUGIN MODULE HEADER
 *
 * @module: guestbook
 * @name: Mural de Recados
 * @description: Adiciona uma p&aacute;gina de recados ao site. O moderador/administrador poder&aacute; alterar confitura&ccedil;oes deste m&oacute;dulo ou excluir/moderar as mensagens enviadas.
 * @version: 0.5
 * @created: 2009-04-26
 * @modified: 2009-12-21
 * @author: Igo Santos
 * @author_email: web@igosantos.com
 * @author_url: www.igosantos.com
 * @actions: eko_guestbook, eko_guestbook_config
 * @required_modules: core
 *
 *    Copyright (C) 2009  Igo Santos <web@igosantos.com>
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/

//update the module database tables
function eko_guestbook_db_update()
{
	$sql[0] = "CREATE TABLE IF NOT EXISTS ".EKO_DB_PREFIX."eko_guestbook_config(`id` int(11) NOT NULL auto_increment PRIMARY KEY);";
	$sql[1] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook_config ADD COLUMN `nome` VARCHAR( 255 ) NOT NULL;";
	$sql[2] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook_config ADD COLUMN `valor` VARCHAR( 255 ) NOT NULL;";

	$sql[3] = "INSERT INTO `".EKO_DB_PREFIX."eko_guestbook_config` (`id`, `nome`, `valor`) VALUES (1, 'msgs_per_page', '15')";
	
	$sql[4] = "CREATE TABLE IF NOT EXISTS ".EKO_DB_PREFIX."eko_guestbook (`id` int(11) NOT NULL auto_increment PRIMARY KEY);";
	$sql[5] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `datahora` DATETIME NOT NULL;";
	$sql[6] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `nome` VARCHAR( 255 ) NOT NULL;";
	$sql[7] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `email` VARCHAR( 255 ) NOT NULL;";
	$sql[8] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `url` VARCHAR( 255 ) NOT NULL;";
	$sql[9] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `msg` TEXT NOT NULL;";
	$sql[10] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `user_id` INT NOT NULL;";
	$sql[11] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `status` INT NOT NULL;";
	
	$ret = array();

	$erros = "";
	
	for($i=0;$i<count($sql);$i++)
	{
		if (!mysql_query($sql[$i])) $erros .="<li>[SQL$i]:".mysql_error()."</li>";
	};
	
	if($erros=="")
	{
		$ret[0] = true;
		$ret[1] = "";
	}
	else
	{
		$ret[0] = false;
		$ret[1] = $erros;
	};

	return $ret;
	
};

//drop previously created database tables
function eko_guestbook_db_drop()
{
	$sql[0] = "DROP TABLE IF EXISTS ".EKO_DB_PREFIX."eko_guestbook_config;";
	$sql[1] = "DROP TABLE IF EXISTS ".EKO_DB_PREFIX."eko_guestbook;";
	
	$ret = array();

	$erros = "";
	
	for($i=0;$i<count($sql);$i++)
	{
		if (!mysql_query($sql[$i])) $erros .="<li>[SQL$i]:".mysql_error()."</li>";
	};
	
	if($erros=="")
	{
		$ret[0] = true;
		$ret[1] = "";
	}
	else
	{
		$ret[0] = false;
		$ret[1] = $erros;
	};

	return $ret;
};

//check if the required database tables are installed.
function eko_guestbook_db_check()
{
	$sql[0] = "SELECT id,nome,valor FROM ".EKO_DB_PREFIX."eko_guestbook_config LIMIT 1;";
	$sql[1] = "SELECT id,datahora,nome,email,url,msg,user_id,status FROM ".EKO_DB_PREFIX."eko_guestbook LIMIT 1;";
	
	for ($i=0;$i<count($sql);$i++) if (!mysql_query($sql[$i])) return false;
	
	return true;
};

//the module css
function eko_guestbook_css()
{
	?>
    /* eko_guestbook_css <style-> */
	
	.eko_guestbook_textarea {
		width:100%;
	}
	
    .eko_guestbook_list li h3 {
    	margin:0px;
        padding:0px;
        border:1px solid;
    }
    /*
	.grey {
	}
    
	.eko_guestbook_content {
		position:relative;
		padding:20px;
	}
	
	.eko_guestbook_item {
		position:relative;
		clear:both;
		padding:20px 0px 20px 0px;
	}

	.eko_guestbook_item_grey {
		background:#f7f7f7;
		border:1px #ddd solid;
		position:relative;
		clear:both;
		padding:20px 0px 20px 0px;
	}

	.eko_guestbook_item_msg {
		padding:10px 0px 10px 0px;
		position:relative;
		clear:both;
	}
	
	.eko_guestbook_item_img {
		padding: 0px 0px 0px 10px;
		position:relative;
		float:left;
		width:110px;
	}
	
	.eko_guestbook_item_title {
		position:relative;
	}

	.eko_guestbook_item_title h2 {
		border-bottom:#ccc 1px dotted;
		font-size:18px;
		font-weight:bold;
	}
	
	.eko_guestbook_item_title h2 a {
		font-size:18px;
		font-weight:bold;
	}
	
	.eko_guestbook_item_title span, .eko_guestbook_item_title span a  {
		font-size:90%;
		font-weight:bold;
	}
    */
    <?
};

//the config form
function eko_guestbook_config()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_guestbook_db_check())
	{
		_warning("Banco de dados n&atilde;o instalado","As tabelas deste m&oacute;dulo ainda n&atilde;o foram instaladas.","./","OK");
		return;
	}
	//check the correct permission!
	eko_core_configform("guestbook",16,eko_get_page_url("eko_guestbook"));
};

//get the module settings
function eko_guestbook_getconfig($nome)
{
	return eko_core_getconfig($nome,"guestbook");
};

function eko_guestbook_list_status_change()
{
	$sql = "SELECT status FROM ".EKO_DB_PREFIX."eko_guestbook WHERE id = ".$_REQUEST["eko_gbk_status_change"];
	$rs = mysql_query($sql);
	$arr = mysql_fetch_array($rs);
	$status = ($arr["status"]) ? "0" : "1" ;
	$sql = "UPDATE ".EKO_DB_PREFIX."eko_guestbook SET status = $status  WHERE id = ".$_REQUEST["eko_gbk_status_change"];
	//echo $arr["status"] . "-->" . $status;
	if(!mysql_query($sql)) _warning("Erro:","<li>".mysql_error()."<li>");
	//mysql_query($sql);
	eko_guestbook_list();
};

//action that outputs some information about this module
function eko_guestbook_list()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_guestbook_db_check())
	{
		_warning("Banco de dados n&atilde;o instalado","As tabelas deste m&oacute;dulo ainda n&atilde;o foram instaladas.","./","OK");
		return;
	}
		
	if (is_user_logged_in())
	{
		$user = wp_get_current_user();
		?>
		<form method="post" action="<?=eko_get_page_url("eko_guestbook","eko_action=2");?>">
			<table class="eko_form-table">
				<tr>
					<th>Nome:</th>
					<td><?=$user->user_nicename;?></td>
				</tr>
				<tr>
					<th>Email:</th>
					<td><?=$user->user_email;?></td>
				</tr>
				<tr>
					<th>Site:</th>
					<td><?=$user->user_url;?></td>
				</tr>
				<tr>
					<th>Mensagem:</th>
					<td><textarea name="msg"></textarea></td>
				</tr>
				<tr>
					<th>&nbsp;</th>
					<td><input class="eko_input_submit" type="submit" value="Enviar!" /></td>
				</tr>
				<? if(getaccess(16)) { ?>
				<tr>
					<th>&nbsp;</th>
					<td><a href="<?=eko_add_querystring_var(eko_get_page_url("eko_guestbook"),"eko_action",1);?>">Configurar este m&oacute;dulo</a></td>
				</tr>
				<? } ?>
			</table>
		</form>
		<?
	}
	else
	{
		?>
		<form method="post" action="<?=eko_get_page_url("eko_guestbook","eko_action=2");?>">
			<table class="eko_form-table">
				<tr>
					<th>Nome:</th>
					<td><input type="text" name="nome" /></td>
				</tr>
				<tr>
					<th>Email:</th>
					<td><input type="text" name="email" /></td>
				</tr>
				<tr>
					<th>Site:</th>
					<td><input type="text" name="url" /></td>
				</tr>
				<tr>
					<th>Mensagem:</th>
					<td><textarea name="msg"></textarea></td>
				</tr>
				<tr>
					<th>&nbsp;</th>
					<td><input class="eko_input_submit" type="submit" value="Enviar!" /></td>
				</tr>
				<? if(getaccess(16)) { ?>
				<tr>
					<th>&nbsp;</th>
					<td><a href="<?=eko_add_querystring_var(eko_get_page_url("eko_guestbook"),"eko_action",1);?>">Configurar este m&oacute;dulo</a></td>
				</tr>
				<? } ?>
			</table>
		</form>
		<?
	};
	
	if(getaccess(17))
	{
		$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_guestbook ORDER BY id DESC LIMIT ".eko_guestbook_getconfig("msgs_per_page");
	}
	else
	{
		$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_guestbook WHERE status = 1 ORDER BY id DESC LIMIT ".eko_guestbook_getconfig("msgs_per_page");
	};
	
    if($rs=mysql_query($sql))
    {
        $i=0;
        while($arr=mysql_fetch_array($rs))
        {
            ?>
            <br />
            <table class="eko_table">
            <thead>
                <th><a href="<?=(($arr["url"]=="http://")||($arr["url"]=="")) ? "#" : $arr["url"] ; ?>"><?=$arr["nome"]?></a> em <?=date("d/m/Y H:i",strtotime($arr["datahora"]));?>:</th>
            </thead>
            <tbody>
                <th><?=linebreakToTag($arr["msg"]);?></th>
            </tbody>
            <? if(getaccess(17)) { ?>
            <tbody>
                <th>
                	<a href="<?=eko_get_page_url("eko_guestbook","eko_action=4&eko_list_id=".$arr["id"]);?>">[excluir]</a>
                    <!-- <a href="<?=eko_get_page_url("eko_guestbook");?>">[editar]</a> -->
                    <a href="<?=eko_get_page_url("eko_guestbook","eko_action=3&eko_gbk_status_change=".$arr["id"]);?>"><? if($arr["status"]==0) {?><b>[publicar]</b><? } else { ?>[despublicar]<? } ?></a>
                </th>
            </tbody>
            <? } ?>
            </table>
            <?
            $i++;
        };
    }
    else
    {
        _warning("Erro ao listar mensagens:","<li>".mysql_query()."</li>");
    };
};

//action for guestbook message submit
function eko_guestbook_list_add()
{
	if (is_user_logged_in())
	{
		$user = wp_get_current_user();
		$id = $user->ID;
		$nome = $user->user_nicename;
		$email = $user->user_email;
		$url = $user->user_url;
		$msg = $_REQUEST["msg"];
		$erros = "";
		$sql = "INSERT INTO ". EKO_DB_PREFIX . "eko_guestbook VALUES (NULL,CURRENT_TIMESTAMP,'$nome','$email','$url','$msg','$id',1)";
		
		if ($msg=="")
		{
			$erros .= "<li>O campo MENSAGEM &eacute; obrigat&oacute;rio.</li>";
		};
		
		if ($erros=="")
		{
			if(mysql_query($sql))
			{
				_info("Sucesso!","Sua mensagem foi enviada com sucesso!",eko_get_page_url("eko_guestbook"));
			}
			else
			{
				_warning("N&atilde;o foi poss&iacute;vel enviar a mensagem devido ao(s) seguinte(s) erro(s):","<li>".mysql_error()."</li>",eko_get_page_url("eko_guestbook"),"Voltar");
			};
		}
		else
		{
			_warning("N&atilde;o foi poss&iacute;vel enviar a mensagem devido ao(s) seguinte(s) erro(s):",$erros,eko_get_page_url("eko_guestbook"),"Voltar");
		};
	}
	else
	{
		$id = 0;
		$nome = $_REQUEST["nome"];
		$email = $_REQUEST["email"];
		$url = $_REQUEST["url"];
		$msg = $_REQUEST["msg"];
		$erros = "";
		$sql = "INSERT INTO ". EKO_DB_PREFIX . "eko_guestbook VALUES (NULL,CURRENT_TIMESTAMP,'$nome','$email','$url','$msg','$id',0)";
		
		if ($msg=="")
		{
			$erros .= "<li>O campo MENSAGEM &eacute; obrigat&oacute;rio.</li>";
		};
		
		if ($nome=="")
		{
			$erros .= "<li>O campo NOME &eacute; obrigat&oacute;rio.</li>";
		};
		
		if ($email=="")
		{
			$erros .= "<li>O campo EMAIL &eacute; obrigat&oacute;rio.</li>";
		};
		
		if ($erros=="")
		{
			if(mysql_query($sql))
			{
				_info("Sucesso!","Sua mensagem foi enviada com sucesso, mas ainda passar&aacute; pela aprova&ccedil;&atilde;o de nossos moderadores.",eko_get_page_url("eko_guestbook"));
			}
			else
			{
				_warning("N&atilde;o foi poss&iacute;vel enviar a mensagem devido ao(s) seguinte(s) erro(s):","<li>".mysql_error()."</li>",eko_get_page_url("eko_guestbook"),"Voltar");
			};
		}
		else
		{
			_warning("N&atilde;o foi poss&iacute;vel enviar a mensagem devido ao(s) seguinte(s) erro(s):",$erros,eko_get_page_url("eko_guestbook"),"Voltar");
		};
	};
};

function eko_guestbook_list_delete()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_guestbook_db_check())
	{
		_warning("Banco de dados n&atilde;o instalado","As tabelas deste m&oacute;dulo ainda n&atilde;o foram instaladas.","./","OK");
		return;
	}
	
	//check user permission
	
	if(getaccess(16))
	{
		$sql ="DELETE FROM ".EKO_DB_PREFIX."eko_guestbook WHERE id = ".$_REQUEST["eko_list_id"];
		if(!mysql_query($sql)) _warning("Erro ao Excluir Mensagem","<li>".mysql_error()."</li>");
	}
	else
	{
		_noaccess("Acesso Negado","<li>Voc&ecirc; n&atilde;o tem permiss&atilde;o para moderar mensagens.</li>");
	};
	
	eko_guestbook_list();
};

//main action
function eko_guestbook()
{
	switch($_REQUEST["eko_action"])
	{
		case 4:
			eko_guestbook_list_delete();
			break;
		case 3:
			eko_guestbook_list_status_change();
			break;
		case 2:
			eko_guestbook_list_add();
			break;
		case 1:
			eko_guestbook_config();
			break;
		default:
			eko_guestbook_list();
			break;
	};
};

add_action("eko_css","eko_guestbook_css");
?>